#include <QCoreApplication>
#include <QtSql>
#include <QDebug>
#include <QTextCodec>

QString qt_conn()
{

    QSqlDatabase db = QSqlDatabase::addDatabase("QDM");
    db.setHostName("192.168.14.137");
    db.setPort(5236);
    db.setDatabaseName("dm8");
    db.setUserName("SYSDBA");
    db.setPassword("SYSDBA");
    if (db.open())
        qDebug() << "connect ok!";
    else
    {
        qDebug() << "connect fail! " << db.lastError().text().toLatin1();
    }
    return "代码运行成功！";
}


QString qt_dml()
{

    QSqlDatabase db = QSqlDatabase::addDatabase("QDM");
    db.setHostName("192.168.14.137");
    db.setPort(5236);
    db.setDatabaseName("dm8");
    db.setUserName("SYSDBA");
    db.setPassword("SYSDBA");
    if (db.open())
        qDebug() << "connect ok!";
    else
    {
        qDebug() << "connect fail! " << db.lastError().text().toLatin1();
    }

    QSqlQuery query;

    //清空表，初始化测试环境
    QString strsql = "delete from PRODUCTION.PRODUCT_CATEGORY";
    query.exec(strsql);


    //插入数据
    strsql = "insert into PRODUCTION.PRODUCT_CATEGORY(NAME) values('语文'), ('数学'), ('英语'), ('体育')";
    if (query.exec(strsql))
    {
        qDebug() << "insert ok!";
    }
    else
    {
        qDebug() << "insert fail! " << query.lastError().text();
        getchar();
        exit(-1);
    }

    //删除数据
    strsql = "delete from PRODUCTION.PRODUCT_CATEGORY where name='数学'";
    if (query.exec(strsql))
    {
        qDebug() << "delete ok!";
    }
    else
    {
        qDebug() << "delete fail! " << query.lastError().text();
        getchar();
        exit(-1);
    }

    //更新数据
    strsql = "update PRODUCTION.PRODUCT_CATEGORY set name = '英语—新课标' where name='英语';";
    if (query.exec(strsql))
    {
        qDebug() << "update ok!";
    }
    else
    {
        qDebug() << "update fail! " << query.lastError().text();
        getchar();
        exit(-1);
    }

    //查询数据
    strsql = "select name from PRODUCTION.PRODUCT_CATEGORY";
    if (query.exec(strsql))
    {
        qDebug() << "select ok!";
    }
    else
    {
        qDebug() << "select fail! " << query.lastError().text();
        getchar();
        exit(-1);
    }
    while (query.next())
    {
         qDebug() << query.value(0).toString().toStdString().c_str();
    }
    query.clear();

    return "代码运行成功！";
}


QString qt_bind()
{

    QSqlDatabase db = QSqlDatabase::addDatabase("QDM");
    db.setHostName("192.168.14.137");
    db.setPort(5236);
    db.setDatabaseName("dm8");
    db.setUserName("SYSDBA");
    db.setPassword("SYSDBA");
    if (db.open())
        qDebug() << "connect ok!";
    else
    {
        qDebug() << "connect fail! " << db.lastError().text().toLatin1();
    }

    QSqlQuery query;

    //清空表，初始化测试环境
    QString strsql = "delete from PRODUCTION.PRODUCT_CATEGORY";
    query.exec(strsql);


    //绑定参数方式插入数据
    strsql = "insert into PRODUCTION.PRODUCT_CATEGORY(name) values(?)";
    query.prepare(strsql);
    query.bindValue(0, "物理");
    if (query.exec())
    {
        qDebug() << "insert ok!";
    }
    else
    {
        qDebug() << "insert fail! " << query.lastError().text();
        getchar();
        exit(-1);
    }

    //查询数据
    strsql = "select name from PRODUCTION.PRODUCT_CATEGORY";
    if (query.exec(strsql))
    {
        qDebug() << "select ok!";
    }
    else
    {
        qDebug() << "select fail! " << query.lastError().text();
        getchar();
        exit(-1);
    }
    while (query.next())
    {
         qDebug() << query.value(0).toString().toStdString().c_str();
    }
    query.clear();

    return "代码运行成功！";
}


QString qt_lob()
{

    QSqlDatabase db = QSqlDatabase::addDatabase("QDM");
    db.setHostName("192.168.14.137");
    db.setPort(5236);
    db.setDatabaseName("dm8");
    db.setUserName("SYSDBA");
    db.setPassword("SYSDBA");
    if (db.open())
        qDebug() << "connect ok!";
    else
    {
        qDebug() << "connect fail! " << db.lastError().text().toLatin1();
    }

    QSqlQuery query;

    //清理测试环境
    QString strsql = "drop table if exists PRODUCTION.BIG_DATA";
    query.exec(strsql);
    strsql = "create table PRODUCTION.BIG_DATA(c1 int, c2 blob)";
    query.exec(strsql);

    // 读取文件数据，写入 lob 列
    //选择要写入的文件
    QString f = "/data/c_test_code/DM8_SQL.pdf";

    //转换为字节数组
    QByteArray mapData;
    QFile file(f);
    file.open(QIODevice::ReadOnly);
    mapData = file.readAll();
    file.close();

    //插入数据
    query.prepare("INSERT INTO PRODUCTION.BIG_DATA values(?, ?)");
    query.bindValue(0, 1);
    query.bindValue(1, mapData);
    if (!query.exec()) {
        qDebug() << query.lastError();
    } else {
        qDebug() << "insert OK!";
    }

    //读取 lob 列数据，写入到文件中
    QSqlQuery readquery;

    QByteArray databa;
    if (readquery.exec("select c2 from PRODUCTION.BIG_DATA")) {
        QSqlRecord myrecord = readquery.record();

        if (readquery.next()) {
            databa = readquery.value(myrecord.indexOf("C2")).toByteArray();
        }
    }

    QFile mybfile("/data/c_test_code/DM8_4_SQL.pdf");
    mybfile.open(QIODevice::WriteOnly);
    mybfile.write(databa);
    mybfile.close();
    qDebug() << "select OK!";


    return "代码运行成功！";
}


int main(int argc, char *argv[]){

    QCoreApplication a(argc, argv);

    QString info = qt_conn();

//    QString info = qt_dml();

//    QString info = qt_bind();

//    QString info = qt_lob();

    qDebug() << info;

    a.exec();


}
